#include "stdafx.h"
#include "TestDWM.h"
#include "Dlg.h"

#if (! defined __VSSYM32_H__)
	#include <vssym32/vssym32.h>
#endif // (! defined __VSSYM32_H__)

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CDlg::CDlg(
	CWnd * pParent // = NULL
	)
	: CExtNCW < CExtResizableDialog > ( CDlg::IDD, pParent )
{
	//{{AFX_DATA_INIT(CDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon( IDR_MAINFRAME );
	SetAutoSubclassChildControls();
}

CDlg::~CDlg()
{
}

void CDlg::DoDataExchange( CDataExchange * pDX )
{
	CExtNCW < CExtResizableDialog > :: DoDataExchange( pDX );
	//{{AFX_DATA_MAP(CDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP( CDlg, CExtResizableDialog )
	//{{AFX_MSG_MAP(CDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CDlg::OnInitDialog()
{
	CExtNCW < CExtResizableDialog > :: OnInitDialog();
	SetIcon( m_hIcon, TRUE );
	SetIcon( m_hIcon, FALSE );
	DwmFeatures_Init();
	AddAnchor( IDOK, __RDA_RT );	
	AddAnchor( IDCANCEL, __RDA_RT );	
	EnableSaveRestore( _T("ResizableDialogs"), _T("MainDialog") );	
CString strWindowText;
	GetWindowText( strWindowText );
	strWindowText += _T(" (custom drawn caption) - we are very very very very very sorry for the delay with this answer");
	SetWindowText( strWindowText );
	NcFrameImpl_RecalcNcFrame();
	return TRUE;
}

bool CDlg::NcFrameImpl_IsSupported() const
{
	if( ! m_bNcFrameImpl_IsEnabled )
		return false;
bool bDwmMode = g_PaintManager.m_DWM.IsCompositionEnabled() ? true : false;
	if( ! bDwmMode )
		return false;
	return true;
}

bool CDlg::NcFrameImpl_IsDwmCaptionReplacement() const
{
	if( ! NcFrameImpl_IsDwmBased() )
		return false;
	return true;	
}

void CDlg::NcFrameImpl_PostWindowProc( LRESULT & lResult, UINT message, WPARAM wParam, LPARAM lParam )
{
	CExtNCW < CExtResizableDialog > :: NcFrameImpl_PostWindowProc( lResult, message, wParam, lParam );
	switch( message )
	{
	case WM_NCPAINT:
		if( NcFrameImpl_IsDwmCaptionReplacement() )
		{
 			CWindowDC dcWnd( this );
			CRect rcWnd, rcClient;
			GetWindowRect( &rcWnd );
			GetClientRect( &rcClient );
			ClientToScreen( &rcClient );
			rcClient.OffsetRect( -rcWnd.TopLeft() );
			rcWnd.OffsetRect( -rcWnd.TopLeft() );
			dcWnd.ExcludeClipRect( &rcClient );
			CExtMemoryDC dc( &dcWnd, &rcWnd );
			dc.FillSolidRect( &rcWnd, RGB(0,0,0) );
			if(	g_PaintManager.m_UxTheme.OpenThemeDataEx( m_hWnd, VSCLASS_WINDOW, __EXT_UX_OTD_NONCLIENT ) != NULL )
			{ // if extended theme data was open successfully
				CString strWindowText;
				GetWindowText( strWindowText );
				if( ! strWindowText.IsEmpty() )
				{
					bool bRTL = ( (GetExStyle()&WS_EX_LAYOUTRTL) != 0 ) ? true : false;
					static const int g_nDwmGlowSize2007 = 10;
					DWORD dwOldLayout1 = LAYOUT_LTR, dwOldLayout2 = LAYOUT_LTR;
					if( bRTL )
						dwOldLayout1 = dc.SetLayout( LAYOUT_RTL );
					RECT rcCaptionButtonBounds = { 0, 0, 0, 0 };
					HRESULT hr = g_PaintManager.m_DWM.DwmGetWindowAttribute( m_hWnd, CExtDWM::__EXT_DWMWA_CAPTION_BUTTON_BOUNDS, &rcCaptionButtonBounds, sizeof(rcCaptionButtonBounds) );
					ASSERT( SUCCEEDED(hr) );
					hr;
					CRect rcText( rcWnd );
					rcText.bottom = rcClient.top;
					rcText.right = min( rcText.right, rcCaptionButtonBounds.left );
					rcText.DeflateRect( abs( rcWnd.left - rcClient.left ), 0, abs( rcWnd.right - rcClient.right ), 0 );
					CExtMemoryDC dc32( &dc, &rcText, CExtMemoryDC::MDCOPT_TO_MEMORY|CExtMemoryDC::MDCOPT_FORCE_DIB|CExtMemoryDC::MDCOPT_FILL_BITS|CExtMemoryDC::MDCOPT_DIB_NEGATIVE_HEIGHT );
					ASSERT( dc32.GetSafeHdc() != NULL );
					dc.FillSolidRect( &rcText, RGB(0,0,0) );
					if( bRTL )
						dwOldLayout2 = dc32.SetLayout( LAYOUT_RTL );
					CFont * pOldFont = dc32.SelectObject( &g_PaintManager->m_FontCaption );
					CExtUxTheme::__EXT_UX_DTTOPTS dto = { sizeof(CExtUxTheme::__EXT_UX_DTTOPTS) };
					dto.dwFlags = __EXT_UX_DTT_TEXTCOLOR;
					dto.iGlowSize = g_nDwmGlowSize2007;
					if( ( ! g_PaintManager.m_bIsWin7OrLater ) && IsZoomed() )
						dto.crText = RGB(0x0FF,0x0FF,0x0FF);
					else
					{
						dto.dwFlags |= __EXT_UX_DTT_COMPOSITED|__EXT_UX_DTT_GLOWSIZE;
						bool bFrameActive = NcFrameImpl_IsActive();
						dto.crText = bFrameActive ? RGB(0,0,0) : RGB(0x060,0x060,0x060);
					}
					g_PaintManager.m_UxTheme.DrawThemeTextEx( dc32.m_hDC, 0, 0, strWindowText, -1, DT_SINGLELINE|DT_CENTER|DT_VCENTER|DT_NOPREFIX|DT_END_ELLIPSIS, rcText, &dto );
					dc32.SelectObject( pOldFont );
					if( bRTL )
					{
						dc.SetLayout( dwOldLayout1 );
						dc32.SetLayout( dwOldLayout2 );
					} // if( bRTL )
				} // if( ! strWindowText.IsEmpty() )
				g_PaintManager.m_UxTheme.CloseThemeData();
			} // if extended theme data was open successfully

		} // if( hWnd != NULL && ::IsWindow( hWnd ) )
	break;
	} // switch( message )
}

void CDlg::DwmFeatures_Init()
{
	m_bNcFrameImpl_IsEnabled = m_bNcFrameImpl_IsDwmBased = true;
}
